//+------------------------------------------------------------------+
//|                                         boincinPipEA_BigBear.mq4 |
//|                      Copyright                    Neamtu Victor |
//|                                          neamtu_victor@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
extern int StopLoss=30;
extern bool useStopLoss=true;

extern double Lots = 2;
extern bool Auto_Lots = true;
extern int  Risk = 10;
extern double MIN_lots = 2;
extern double MAX_lots = 100;

//signal+filters
bool okNormalUp,okNormalDown; //true =normal signal up, false=normal signal down
bool okNldUp,okNldDown;

int init(){
  
     okNormalUp=false;
     okNormalDown=false;
     
     okNldUp=false;
     okNldDown=false; 
     
     double zz_vic;
     //view
     zz_vic=iCustom(NULL,0,"ZigZag Pointer_Victor",0,0); 
     zz_vic=iCustom(NULL,0,"zigzag-pointer_Victor",0,0); 

   return(0);
}

int deinit(){
   return(0);
}

void alertDisplay(double zUp, double zDown, double nZig){
   string output="";
   bool ok=false;
   
   if (zUp != 0){
      output=output+" ZigZagUP: "+ zUp;
      ok=true;
   }
   if (zDown != 0){
      output=output+" ZigZagDown: "+ zDown;
      ok=true;
   }
   if (nZig != 0){
      output=output+" NonLagZigZag: "+ nZig;
      ok=true;
   }
   
   if (ok == true){
      Alert(output);
   }
   else{
      Alert("time display");
   }
   
   return(0);
}



//*****************************************************************************************************************************************************
//*****************************************************************************Needed Functions*******************************************************
//*****************************************************************************************************************************************************

void orderClose(int ticket){
   
   if (OrderSelect(ticket,SELECT_BY_TICKET) == true){
     if (OrderType() == OP_BUY){
        OrderClose(ticket,Lots,Bid,0,Green);
     }
     if (OrderType() == OP_SELL){
        OrderClose(ticket,Lots,Ask,0,Red);
     }
   }
   
   return(0);
}

double calculateSL(bool BuySell){ //true=> Buy, false=> Sell
   double sl;
   
   if (useStopLoss == true){
      
      if (BuySell == true){ // buy order
         sl = iLow(Symbol(),Period(),0)-StopLoss*Point;
      }
      else{
         sl = iHigh(Symbol(),Period(),0)+StopLoss*Point; 
      }
      
   }
   else{
      sl=0;
   }

   return (sl);
}

//*****************************************************************************************************************************************************
//*****************************************************************************Needed Functions*******************************************************
//*****************************************************************************************************************************************************



//*****************************************************************************************************************************************************
//***************************************************************************** M-M *******************************************************************
//*****************************************************************************************************************************************************

double AutoLots(){

   int Decimals = 0;
   int AccLeverage = 100;
   double MaxLotPurchase = 0;
   double ModeLotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   double ModeLotSize = MarketInfo(Symbol(), MODE_LOTSIZE);
   
   
   if(Auto_Lots == false){
      return(Lots);
   }
       
   if(ModeLotStep == 0.01){
      Decimals = 2;
   }
   if(ModeLotStep == 0.1){
      Decimals = 1;
   }
   
   if(ModeLotSize != 0){
      MaxLotPurchase=((AccountEquity()*AccLeverage)/ModeLotSize)*(Risk*0.01);
   }
   else{
      MaxLotPurchase=MIN_lots;
   }
      
   Lots = StrToDouble(DoubleToStr(MaxLotPurchase,Decimals));
  
   if (Lots < MIN_lots){
      Lots = MIN_lots;
   }
   if (Lots > MAX_lots){
      Lots = MAX_lots;
   }

   return(Lots);    
}

//*****************************************************************************************************************************************************
//***************************************************************************** M-M *******************************************************************
//*****************************************************************************************************************************************************





//*****************************************************************************************************************************************************
//*****************************************************************************Signals + Filters*******************************************************
//*****************************************************************************************************************************************************

void normalSignal(int shift){
   double ZigZagUp,ZigZagDown;
   double NonLagZigZag;
   
   
   NonLagZigZag=iCustom(NULL,0,"NonLagZigZag_v2",0,shift);   
   
   ZigZagUp=iCustom(NULL,0,"ZigZag Pointer",0,shift);
   ZigZagDown=iCustom(NULL,0,"ZigZag Pointer",1,shift);
   
   
   if ((ZigZagUp != 0) && (ZigZagUp == NonLagZigZag)){ //up arrow & nonlag
       okNormalUp=true;  
       okNormalDown=false;  
       //Alert("UP");
   }
   if ((ZigZagDown != 0) && (ZigZagDown == NonLagZigZag)){ //down arrow & nonlag
       okNormalDown=true;
       okNormalUp=false;
       //Alert("Down");
   }
     
   return (0);
}


void nldFilter(int shift){
   double nld_Up,nld_Down;
   
   nld_Up=iCustom(NULL,0,"nonlagdot",1,shift);
   nld_Down=iCustom(NULL,0,"nonlagdot",2,shift);
   
   if (nld_Up != 0){
      okNldUp=true;
      okNldDown=false;
   }
   if (nld_Down != 0){
      okNldDown=true;
      okNldUp=false;
   }
   
   return(0);
}



void closeFilters(){
   okNormalUp=false;
   okNormalDown=false;
   okNldUp=false;
   okNldDown=false;
   
   return(0);
}
//*****************************************************************************************************************************************************
//*****************************************************************************Signals + Filters*******************************************************
//*****************************************************************************************************************************************************






int start(){
   
   static datetime dtBarTime = 0;
   static int ticket; 
   
   
   if (dtBarTime == Time[0]) return(0);  
   dtBarTime = Time[0];
   
   
   
   normalSignal(1);
   nldFilter(1);
   
   
   
   
   if ((okNormalUp == true) && (okNldUp == true)){
   
       orderClose(ticket);
       ticket=OrderSend(Symbol(),OP_BUY,AutoLots(),Ask,3,calculateSL(true),0,"",1,0,Green); 
       
       closeFilters();
   }
   if ((okNormalDown == true) && (okNldDown == true)){
      
       orderClose(ticket);   
       ticket=OrderSend(Symbol(),OP_SELL,AutoLots(),Bid,3,calculateSL(false),0,"",2,0,Red);      
       
       closeFilters();
   }
   
   
   
   
   
   
   return(0);
}




//+------------------------------------------------------------------+